#include <SPI.h>
#include <Ethernet.h>
#include <SD.h>
#define REQ_BUF_SZ   20
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
IPAddress ip(192, 168, 1, 89); 
EthernetServer server(80);  
File webFile;
char HTTP_req[REQ_BUF_SZ] = {0}; 
char req_index = 0;  
void setup()
{
    pinMode(53, OUTPUT);
    digitalWrite(53, HIGH);
    Serial.begin(9600);      
    Serial.println("Initializing SD card...");
    if (!SD.begin(4)) 
    {
        Serial.println("ERROR - SD card initialization failed!");
        return;    
    }
    Serial.println("SUCCESS - SD card initialized.");
    // check for index.htm file
    if (!SD.exists("index.htm")) 
    {
        Serial.println("ERROR - Can't find index.htm file!");
        return;  
    }
    Serial.println("SUCCESS - Found index.htm file.");   
    Ethernet.begin(mac, ip); 
    server.begin();          
}
void loop()
{
    EthernetClient client = server.available(); 
    if (client) 
    {  
        boolean currentLineIsBlank = true;
        while (client.connected()) 
        {
            if (client.available()) 
            {   
                char c = client.read(); 
                
               
                if (req_index < (REQ_BUF_SZ - 1)) 
                {
                    HTTP_req[req_index] = c;        
                    req_index++;
                }               
                Serial.print(c);
                if (c == '\n' && currentLineIsBlank) 
                {
                    if (StrContains(HTTP_req, "GET / ") || StrContains(HTTP_req, "GET /index.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("index.htm");    
                    }
                    else if (StrContains(HTTP_req, "GET /p1.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p1.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p2.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p2.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p3.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p3.htm");     
                    }
                    else if (StrContains(HTTP_req,"GET /p4.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p4.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p5.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p5.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p6.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p6.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p7.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p7.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p8.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p8.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p9.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p9.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /p10.htm")) 
                    {
                        client.println("HTTP/1.1 200 OK");
                        client.println("Content-Type: text/html");
                        client.println("Connnection: close");
                        client.println();
                        webFile = SD.open("p10.htm");     
                    }
                    else if (StrContains(HTTP_req, "GET /1.jpg")) 
                    {
                        webFile = SD.open("1.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /2.jpg")) 
                    {
                        webFile = SD.open("2.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /3.jpg")) 
                    {
                        webFile = SD.open("3.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /4.jpg")) 
                    {
                        webFile = SD.open("4.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /5.jpg")) 
                    {
                        webFile = SD.open("5.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /6.jpg")) 
                    {
                        webFile = SD.open("6.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /7.jpg")) 
                    {
                        webFile = SD.open("7.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /8.jpg")) 
                    {
                        webFile = SD.open("8.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /9.jpg")) 
                    {
                        webFile = SD.open("9.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    else if (StrContains(HTTP_req, "GET /10.jpg")) 
                    {
                        webFile = SD.open("10.jpg");
                        if (webFile) 
                        {
                            client.println("HTTP/1.1 200 OK");
                            client.println();
                        }
                    }
                    if (webFile) 
                    {
                        while(webFile.available()) 
                        {
                            client.write(webFile.read()); 
                        }
                        webFile.close();
                    }
                    req_index = 0;
                    StrClear(HTTP_req, REQ_BUF_SZ);
                    break;
                }
                if (c == '\n') 
                {
                    currentLineIsBlank = true;
                } 
                else if (c != '\r') 
                {
                    currentLineIsBlank = false;
                }
            } 
        } 
        delay(1);      
        client.stop(); 
    } 
}
void StrClear(char *str, char length)
{
    for (int i = 0; i < length; i++) 
    {
        str[i] = 0;
    }
}
char StrContains(char *str, char *sfind)
{
    char found = 0;
    char index = 0;
    char len;
    len = strlen(str);   
    if (strlen(sfind) > len) 
    {
        return 0;
    }
    while (index < len) 
    {
        if (str[index] == sfind[found]) 
        {
            found++;
            if (strlen(sfind) == found) 
            {
                return 1;
            }
        }
        else 
        {
            found = 0;
        }
        index++;
    }
    return 0;
}
